module Data.SpirV.Reflect.Enums.Format where

import Data.SpirV.Reflect.Enums.Common

newtype Format = Format Int
  deriving (Eq, Ord, Show, Enum)

pattern FORMAT_UNDEFINED :: Format
pattern FORMAT_UNDEFINED = Format 0

pattern FORMAT_R32_UINT :: Format
pattern FORMAT_R32_UINT = Format 98

pattern FORMAT_R32_SINT :: Format
pattern FORMAT_R32_SINT = Format 99

pattern FORMAT_R32_SFLOAT :: Format
pattern FORMAT_R32_SFLOAT = Format 100

pattern FORMAT_R32G32_UINT :: Format
pattern FORMAT_R32G32_UINT = Format 101

pattern FORMAT_R32G32_SINT :: Format
pattern FORMAT_R32G32_SINT = Format 102

pattern FORMAT_R32G32_SFLOAT :: Format
pattern FORMAT_R32G32_SFLOAT = Format 103

pattern FORMAT_R32G32B32_UINT :: Format
pattern FORMAT_R32G32B32_UINT = Format 104

pattern FORMAT_R32G32B32_SINT :: Format
pattern FORMAT_R32G32B32_SINT = Format 105

pattern FORMAT_R32G32B32_SFLOAT :: Format
pattern FORMAT_R32G32B32_SFLOAT = Format 106

pattern FORMAT_R32G32B32A32_UINT :: Format
pattern FORMAT_R32G32B32A32_UINT = Format 107

pattern FORMAT_R32G32B32A32_SINT :: Format
pattern FORMAT_R32G32B32A32_SINT = Format 108

pattern FORMAT_R32G32B32A32_SFLOAT :: Format
pattern FORMAT_R32G32B32A32_SFLOAT = Format 109

pattern FORMAT_R64_UINT :: Format
pattern FORMAT_R64_UINT = Format 110

pattern FORMAT_R64_SINT :: Format
pattern FORMAT_R64_SINT = Format 111

pattern FORMAT_R64_SFLOAT :: Format
pattern FORMAT_R64_SFLOAT = Format 112

pattern FORMAT_R64G64_UINT :: Format
pattern FORMAT_R64G64_UINT = Format 113

pattern FORMAT_R64G64_SINT :: Format
pattern FORMAT_R64G64_SINT = Format 114

pattern FORMAT_R64G64_SFLOAT :: Format
pattern FORMAT_R64G64_SFLOAT = Format 115

pattern FORMAT_R64G64B64_UINT :: Format
pattern FORMAT_R64G64B64_UINT = Format 116

pattern FORMAT_R64G64B64_SINT :: Format
pattern FORMAT_R64G64B64_SINT = Format 117

pattern FORMAT_R64G64B64_SFLOAT :: Format
pattern FORMAT_R64G64B64_SFLOAT = Format 118

pattern FORMAT_R64G64B64A64_UINT :: Format
pattern FORMAT_R64G64B64A64_UINT = Format 119

pattern FORMAT_R64G64B64A64_SINT :: Format
pattern FORMAT_R64G64B64A64_SINT = Format 120

pattern FORMAT_R64G64B64A64_SFLOAT :: Format
pattern FORMAT_R64G64B64A64_SFLOAT = Format 121

formatName :: IsString label => Format -> Maybe label
formatName = toLabel formatNames

formatNames :: IsString label => [(Format, label)]
formatNames =
  [ (FORMAT_UNDEFINED, "UNDEFINED")
  , (FORMAT_R32_UINT, "R32_UINT")
  , (FORMAT_R32_SINT, "R32_SINT")
  , (FORMAT_R32_SFLOAT, "R32_SFLOAT")
  , (FORMAT_R32G32_UINT, "R32G32_UINT")
  , (FORMAT_R32G32_SINT, "R32G32_SINT")
  , (FORMAT_R32G32_SFLOAT, "R32G32_SFLOAT")
  , (FORMAT_R32G32B32_UINT, "R32G32B32_UINT")
  , (FORMAT_R32G32B32_SINT, "R32G32B32_SINT")
  , (FORMAT_R32G32B32_SFLOAT, "R32G32B32_SFLOAT")
  , (FORMAT_R32G32B32A32_UINT, "R32G32B32A32_UINT")
  , (FORMAT_R32G32B32A32_SINT, "R32G32B32A32_SINT")
  , (FORMAT_R32G32B32A32_SFLOAT, "R32G32B32A32_SFLOAT")
  , (FORMAT_R64_UINT, "R64_UINT")
  , (FORMAT_R64_SINT, "R64_SINT")
  , (FORMAT_R64_SFLOAT, "R64_SFLOAT")
  , (FORMAT_R64G64_UINT, "R64G64_UINT")
  , (FORMAT_R64G64_SINT, "R64G64_SINT")
  , (FORMAT_R64G64_SFLOAT, "R64G64_SFLOAT")
  , (FORMAT_R64G64B64_UINT, "R64G64B64_UINT")
  , (FORMAT_R64G64B64_SINT, "R64G64B64_SINT")
  , (FORMAT_R64G64B64_SFLOAT, "R64G64B64_SFLOAT")
  , (FORMAT_R64G64B64A64_UINT, "R64G64B64A64_UINT")
  , (FORMAT_R64G64B64A64_SINT, "R64G64B64A64_SINT")
  , (FORMAT_R64G64B64A64_SFLOAT, "R64G64B64A64_SFLOAT")
  ]
