module Data.SpirV.Reflect.Enums.SpirvDim where

import Data.SpirV.Reflect.Enums.Common

newtype Dim = Dim Int32
  deriving newtype (Eq, Ord, Show, Enum, Bounded)

pattern Dim1D :: Dim
pattern Dim1D = Dim 0

pattern Dim2D :: Dim
pattern Dim2D = Dim 1

pattern Dim3D :: Dim
pattern Dim3D = Dim 2

pattern DimCube :: Dim
pattern DimCube = Dim 3

pattern DimRect :: Dim
pattern DimRect = Dim 4

pattern DimBuffer :: Dim
pattern DimBuffer = Dim 5

pattern DimSubpassData :: Dim
pattern DimSubpassData = Dim 6

pattern DimMax :: Dim
pattern DimMax = Dim 0x7fffffff
