module Data.SpirV.Reflect.Enums.SpirvImageFormat where

import Data.SpirV.Reflect.Enums.Common

newtype ImageFormat = ImageFormat Int32
  deriving newtype (Eq, Ord, Show, Enum, Bounded)

pattern ImageFormatUnknown :: ImageFormat
pattern ImageFormatUnknown = ImageFormat 0

pattern ImageFormatRgba32f :: ImageFormat
pattern ImageFormatRgba32f = ImageFormat 1

pattern ImageFormatRgba16f :: ImageFormat
pattern ImageFormatRgba16f = ImageFormat 2

pattern ImageFormatR32f :: ImageFormat
pattern ImageFormatR32f = ImageFormat 3

pattern ImageFormatRgba8 :: ImageFormat
pattern ImageFormatRgba8 = ImageFormat 4

pattern ImageFormatRgba8Snorm :: ImageFormat
pattern ImageFormatRgba8Snorm = ImageFormat 5

pattern ImageFormatRg32f :: ImageFormat
pattern ImageFormatRg32f = ImageFormat 6

pattern ImageFormatRg16f :: ImageFormat
pattern ImageFormatRg16f = ImageFormat 7

pattern ImageFormatR11fG11fB10f :: ImageFormat
pattern ImageFormatR11fG11fB10f = ImageFormat 8

pattern ImageFormatR16f :: ImageFormat
pattern ImageFormatR16f = ImageFormat 9

pattern ImageFormatRgba16 :: ImageFormat
pattern ImageFormatRgba16 = ImageFormat 10

pattern ImageFormatRgb10A2 :: ImageFormat
pattern ImageFormatRgb10A2 = ImageFormat 11

pattern ImageFormatRg16 :: ImageFormat
pattern ImageFormatRg16 = ImageFormat 12

pattern ImageFormatRg8 :: ImageFormat
pattern ImageFormatRg8 = ImageFormat 13

pattern ImageFormatR16 :: ImageFormat
pattern ImageFormatR16 = ImageFormat 14

pattern ImageFormatR8 :: ImageFormat
pattern ImageFormatR8 = ImageFormat 15

pattern ImageFormatRgba16Snorm :: ImageFormat
pattern ImageFormatRgba16Snorm = ImageFormat 16

pattern ImageFormatRg16Snorm :: ImageFormat
pattern ImageFormatRg16Snorm = ImageFormat 17

pattern ImageFormatRg8Snorm :: ImageFormat
pattern ImageFormatRg8Snorm = ImageFormat 18

pattern ImageFormatR16Snorm :: ImageFormat
pattern ImageFormatR16Snorm = ImageFormat 19

pattern ImageFormatR8Snorm :: ImageFormat
pattern ImageFormatR8Snorm = ImageFormat 20

pattern ImageFormatRgba32i :: ImageFormat
pattern ImageFormatRgba32i = ImageFormat 21

pattern ImageFormatRgba16i :: ImageFormat
pattern ImageFormatRgba16i = ImageFormat 22

pattern ImageFormatRgba8i :: ImageFormat
pattern ImageFormatRgba8i = ImageFormat 23

pattern ImageFormatR32i :: ImageFormat
pattern ImageFormatR32i = ImageFormat 24

pattern ImageFormatRg32i :: ImageFormat
pattern ImageFormatRg32i = ImageFormat 25

pattern ImageFormatRg16i :: ImageFormat
pattern ImageFormatRg16i = ImageFormat 26

pattern ImageFormatRg8i :: ImageFormat
pattern ImageFormatRg8i = ImageFormat 27

pattern ImageFormatR16i :: ImageFormat
pattern ImageFormatR16i = ImageFormat 28

pattern ImageFormatR8i :: ImageFormat
pattern ImageFormatR8i = ImageFormat 29

pattern ImageFormatRgba32ui :: ImageFormat
pattern ImageFormatRgba32ui = ImageFormat 30

pattern ImageFormatRgba16ui :: ImageFormat
pattern ImageFormatRgba16ui = ImageFormat 31

pattern ImageFormatRgba8ui :: ImageFormat
pattern ImageFormatRgba8ui = ImageFormat 32

pattern ImageFormatR32ui :: ImageFormat
pattern ImageFormatR32ui = ImageFormat 33

pattern ImageFormatRgb10a2ui :: ImageFormat
pattern ImageFormatRgb10a2ui = ImageFormat 34

pattern ImageFormatRg32ui :: ImageFormat
pattern ImageFormatRg32ui = ImageFormat 35

pattern ImageFormatRg16ui :: ImageFormat
pattern ImageFormatRg16ui = ImageFormat 36

pattern ImageFormatRg8ui :: ImageFormat
pattern ImageFormatRg8ui = ImageFormat 37

pattern ImageFormatR16ui :: ImageFormat
pattern ImageFormatR16ui = ImageFormat 38

pattern ImageFormatR8ui :: ImageFormat
pattern ImageFormatR8ui = ImageFormat 39

pattern ImageFormatR64ui :: ImageFormat
pattern ImageFormatR64ui = ImageFormat 40

pattern ImageFormatR64i :: ImageFormat
pattern ImageFormatR64i = ImageFormat 41

pattern ImageFormatMax :: ImageFormat
pattern ImageFormatMax = ImageFormat 0x7fffffff
